<?php
/*****************************************************************************/
/* Stats.php                                                                */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$statsphpver = 'YaBB SE 1.5.1';

function display_stats()
{
	global $txt, $color, $yytitle, $boardurl, $yyheaderdone, $settings, $months, $db_prefix, $username, $REMOTE_ADDR, $REQUEST_URI, $modSettings, $imagesdir, $mbname, $sourcedir, $totalt, $totalm, $messnum, $scripturl, $cgi;
	$yytitle = "$mbname - $txt[yse_stats_1]";
	$request = mysql_query("SELECT memberName, realName FROM {$db_prefix}members ORDER BY dateRegistered DESC LIMIT 1;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_array($request);
	$name = ((!isset($temp['realName']) || $temp['realName'] == '') ? $temp['memberName'] : $temp['realName']);

	$euser = urlencode($temp['memberName']);
	$thelatestmember = "<a href=\"$scripturl?action=viewprofile;user=$euser\">$name</a>";
	$result = mysql_query("SELECT COUNT(*) AS memcount FROM {$db_prefix}members;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$memcount = $temp[0];
	$result = mysql_query("SELECT COUNT(*) AS totalm FROM {$db_prefix}messages;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$totalm = $temp[0];
	$result = mysql_query("SELECT COUNT(*) AS totalt FROM {$db_prefix}topics;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$totalt = $temp[0];
	$result = mysql_query("SELECT COUNT(*) AS totalb FROM {$db_prefix}boards;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$numboards = $temp[0];
	$result = mysql_query("SELECT COUNT(*) AS totalc FROM {$db_prefix}categories;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$numcats = $temp[0];
	$result = mysql_query("SELECT COUNT(*) AS click_total FROM {$db_prefix}log_clicks;") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$yyclicks = $temp[0];
	$result = mysql_query("SELECT value FROM {$db_prefix}settings WHERE variable='mostOnline';") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$mostonline = $temp[0];
	$result = mysql_query("SELECT value FROM {$db_prefix}settings WHERE variable='mostDate';") or database_error(__FILE__, __LINE__);
	$temp = mysql_fetch_row($result);
	$mostdate = timeformat($temp[0]);
	# Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\"><b>$mbname</b></a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<b><a href=\"$cgi;action=stats\" class=\"nav\">$txt[yse_stats_1]</a></b></font>" : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=stats\" class=\"nav\"><b>$txt[yse_stats_1]</b></a></font><br />");
	if (!$yyheaderdone)
		template_header();
	echo '
		<table width="100%" align="center"><tr><td valign="bottom">' . $displayLinkTree . '</td></tr></table>
		<table border="0" width="100%" cellspacing="0" cellpadding="0" class="bordercolor">
			<tr>
				<td>
					<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
						<tr>
							<td class="titlebg" align="center" colspan="4"><b>' . $mbname . ' - ' . $txt['yse_stats_1'] . '</b></td>
						</tr>
						<tr>
							<td class="catbg" colspan="4"><b>' . $txt['yse_stats_2'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/stats_info.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2" width="100%" colspan="3">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">
									<tr>
										<td><font size="2">' . $txt[488] . '</font></td>
										<td align="right"><font size="2"><a href="' . $scripturl . '?action=mlall">' . $memcount . '</a></font></td>
									</tr><tr>
										<td><font size="2">' . $txt[489] . '</font></td>
										<td align="right"><font size="2">' . $totalm . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[490] . '</font></td>
										<td align="right"><font size="2">' . $totalt . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[658] . '</font></td>
										<td align="right"><font size="2">' . $numcats . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[665] . '</font></td>
										<td align="right"><font size="2">' . $numboards . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[691] . ' <font size="1">(' . $txt[692] . ')</font>:</font></td>
										<td align="right"><font size="2">' . $yyclicks . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[656] . '</font></td>
										<td align="right"><font size="2">' . $thelatestmember . '</font></td>
									</tr><tr>
										<td><font size="2">' . $txt[888] . '</font></td>
										<td align="right"><font size="2">' . $mostonline . ' - ' . $mostdate . '</font></td>
									</tr>
								</table>
							</td>
						</tr><tr>
							<td class="catbg" colspan="2" width="50%"><b>' . $txt['yse_stats_3'] . '</b></td>
							<td class="catbg" colspan="2" width="50%"><b>' . $txt['yse_stats_4'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/stats_posters.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2" width="50%" valign="top">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">';
	// Poster top 10
	$members_result = mysql_query("SELECT * FROM {$db_prefix}members ORDER BY posts DESC LIMIT 10;") or database_error(__FILE__, __LINE__);
	while ($row_members = mysql_fetch_array($members_result))
	{
		$euser = urlencode($row_members['memberName']);
		echo '
									<tr>
										<td><font size="2"><a href="' . $scripturl . '?action=viewprofile;user=' . $euser . '">' . $row_members['realName'] . '</a></font></td>
										<td align="right"><font size="2">' . $row_members['posts'] . '</font></td>
									</tr>';
	}
	echo '
								</table>
							</td>
							<td class="windowbg" width="20" valign="middle" align="center" nowrap="nowrap"><img src="' . $imagesdir . '/stats_board.gif" width="20" height="20" border="0" alt="" /></td>
							<td class="windowbg2" width="50%" valign="top">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Board top 10
	$condition = ($settings[7] == 'Administrator' || $settings[7] == 'Global Moderator' ? '1' : "(FIND_IN_SET('$settings[7]', c.memberGroups) != 0 || c.memberGroups='')");
	$boards_result = mysql_query("
		SELECT DISTINCT b.ID_BOARD, b.name, b.numPosts
		FROM {$db_prefix}categories AS c
			LEFT JOIN {$db_prefix}boards AS b ON (b.ID_CAT=c.ID_CAT)
		WHERE $condition
		ORDER BY b.numPosts DESC LIMIT 10") or database_error(__FILE__, __LINE__);
	while ($row_board = mysql_fetch_array($boards_result))
	{
		echo '
									<tr>
										<td><font size="2"><a href="' . $scripturl . '?board=' . $row_board['ID_BOARD'] . '">' . $row_board['name'] . '</a></font></td>
										<td align="right"><font size="2">' . $row_board['numPosts'] . '</font></td>
									</tr>';
	}
	echo '
								</table>
							</td>
						</tr><tr>
							<td class="catbg" colspan="2" width="50%"><b>' . $txt['yse_stats_11'] . '</b></td>
							<td class="catbg" colspan="2" width="50%"><b>' . $txt['yse_stats_12'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/stats_replies.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2" width="50%" valign="top">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Topic replies top 10
	$topic_reply_result = mysql_query("SELECT {$db_prefix}topics.*,m.* FROM {$db_prefix}topics,{$db_prefix}messages as m, {$db_prefix}messages as mes WHERE (m.ID_MSG={$db_prefix}topics.ID_FIRST_MSG && mes.ID_MSG={$db_prefix}topics.ID_LAST_MSG) ORDER BY {$db_prefix}topics.numReplies DESC LIMIT 10") or database_error(__FILE__, __LINE__);
	while ($row_topic_reply = mysql_fetch_array($topic_reply_result))
	{
		CensorTxt($row_topic_reply['subject']);
		echo '
									<tr>
										<td><font size="2"><a href="' . $scripturl . '?board=' . $row_topic_reply['ID_BOARD'] . ';action=display;threadid=' . $row_topic_reply['ID_TOPIC'] . ';start=0">' . $row_topic_reply['subject'] . '</a></font></td>
										<td align="right"><font size="2">' . $row_topic_reply['numReplies'] . '</font></td>
									</tr>';
	}
	echo '
								</table>
							</td>
							<td class="windowbg" width="20" valign="middle" align="center" nowrap="nowrap"><img src="' . $imagesdir . '/stats_views.gif" width="20" height="20" border="0" alt="" /></td>
							<td class="windowbg2" width="50%" valign="top">
								<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Topic views top 10
	$topic_view_result = mysql_query("SELECT {$db_prefix}topics.*, m.* FROM {$db_prefix}topics, {$db_prefix}messages AS m, {$db_prefix}messages AS mes WHERE (m.ID_MSG={$db_prefix}topics.ID_FIRST_MSG && mes.ID_MSG={$db_prefix}topics.ID_LAST_MSG) ORDER BY {$db_prefix}topics.numViews DESC LIMIT 10;") or database_error(__FILE__, __LINE__);
	while ($row_topic_view = mysql_fetch_array($topic_view_result))
	{
		CensorTxt($row_topic_view['subject']);
		echo '
									<tr>
										<td><font size="2"><a href="' . $scripturl . '?board=' . $row_topic_view['ID_BOARD'] . ';action=display;threadid=' . $row_topic_view['ID_TOPIC'] . ';start=0">' . $row_topic_view['subject'] . '</a></font></td>
										<td align="right"><font size="2">' . $row_topic_view['numViews'] . '</font></td>
									</tr>';
	}

	$track_hits1 = ($modSettings['hitStats'] ? "<td class=\"titlebg\" valign=\"middle\" align=\"center\">$txt[yse_stats_10]</td>" : "");
	echo '
								</table>
							</td>
						</tr><tr>
							<td class="catbg" colspan="4"><b>' . $txt['yse_stats_5'] . '</b></td>
						</tr><tr>
							<td class="windowbg" width="20" valign="middle" align="center"><img src="' . $imagesdir . '/stats_history.gif" border="0" width="20" height="20" alt="" /></td>
							<td class="windowbg2" colspan="4">
								<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
									<tr>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_6'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_7'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_8'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_9'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_14'] . '</td>
										' . $track_hits1 . '
									</tr>';

	// Days
	$days_result = mysql_query("SELECT * FROM {$db_prefix}log_activity ORDER BY year DESC, month DESC, day DESC LIMIT 30;") or database_error(__FILE__, __LINE__);
	while ($row_days = mysql_fetch_array($days_result))
	{
		$track_hits2 = ($modSettings['hitStats'] ? "<td class=\"windowbg2\">$row_days[hits]</td>" : "");
		echo '
									<tr class="windowbg2" valign="middle" align="center">
										<td class="windowbg2">' . $row_days['day'] . '/' . $row_days['month'] . '/' . $row_days['year'] . '</td>
										<td class="windowbg2">' . $row_days['topics'] . '</td>
										<td class="windowbg2">' . $row_days['posts'] . '</td>
										<td class="windowbg2">' . $row_days['registers'] . '</td>
										<td class="windowbg2">' . $row_days['mostOn'] . '</td>
										' . $track_hits2 . '
									</tr>';
	}
	echo '
								</table><br />
								<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
									<tr>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_13'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_7'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_8'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_9'] . '</td>
										<td class="titlebg" valign="middle" align="center">' . $txt['yse_stats_14'] . '</td>
										' . $track_hits1 . '
									</tr>';

	// Days
	$days_result = mysql_query("SELECT month, year, SUM(hits) AS shit, SUM(registers) AS sreg, SUM(topics) AS stop, SUM(posts) AS spos, MAX(mostOn) AS mOn FROM {$db_prefix}log_activity GROUP BY year, month ORDER BY year DESC, month DESC LIMIT 30;") or database_error(__FILE__, __LINE__);
	while ($row_days = mysql_fetch_array($days_result))
	{
		$tempval = $row_days[month]-1;
		$temp_month = $months[$tempval];
		$track_hits2 = ($modSettings['hitStats'] ? "<td class=\"windowbg2\">$row_days[shit]</td>" : "");
		echo '
									<tr class="windowbg2" valign="middle" align="center">
										<td class="windowbg2">' . $temp_month . ' ' . $row_days['year'] . '</td>
										<td class="windowbg2">' . $row_days['stop'] . '</td>
										<td class="windowbg2">' . $row_days['spos'] . '</td>
										<td class="windowbg2">' . $row_days['sreg'] . '</td>
										<td class="windowbg2">' . $row_days['mOn'] . '</td>
										' . $track_hits2 . '
									</tr>';
	}
	echo '
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>';
	footer();
	exit();
}

?>
